package com.brilliance.isc.funds.fxtlop.service;

import com.brilliance.isc.common.contants.CommonContants;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.vo.BizAmdInfoVo;
import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.fxtlop.check.FxtlopValidator;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.Map;

/**
 * @program: isc-funds
 * @ClassName: FxtlopTransactionServiceImpl
 * @description: 结售汇平盘登记 Fxtlop 业务处理
 * @author: wangweidong
 * @create: 2024-10-08 16:35
 */
@Service("fxtlop.transaction")
public class FxtlopTransactionServiceImpl extends AbstractTransactionService<FxtlopStoreBo> {

    @Resource
    private FxtlopValidator fxtlopValidator;


    @PostConstruct
    public void regisertService() {
        serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.UMDMOD_SERVICE, "N");
        serviceRegisterMaps.put(CommonContants.LIMMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_RMB_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_SZSB_BOPREM_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.BOPSET_CFABOP_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.FANXIQIAN_SERVICE, "Y");
    }


    @Override
    protected void txnSave(FxtlopStoreBo transactionVo) {
        ruleMtabutSavN500(transactionVo);
    }

    public void ruleMtabutSavN500(FxtlopStoreBo bo) {
    }

    @Override
    protected Map<String, String> txnCheck(FxtlopStoreBo transactionVo) {
        return fxtlopValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FxtlopStoreBo transactionVo) {

        return null;
    }

    @Override
    protected BizAmdInfoVo buildBizAmdInfo(FxtlopStoreBo transactionVo) {
        return null;
    }

    @Override
    public FxtlopStoreBo init(FxtlopStoreBo fxtlopStoreBo) {
        fxtlopStoreBo.reset();

        return fxtlopStoreBo;
    }

    @Override
    public void beforeSave(FxtlopStoreBo transactionVo) {
        transactionVo.reset();

    }

    @Override
    protected void updateBizInfoVo(BizInfoVo bizInfoVo, FxtlopStoreBo transactionVo) {
    }


}
